<?php

namespace FiloBlu\ExtInventory\Data;

use Magento\Framework\Data\OptionSourceInterface;
use Magento\InventorySourceSelectionApi\Api\GetSourceSelectionAlgorithmListInterface;

/**
 * Class SourceSelectionAlgorithmOptionSource
 * @package FiloBlu\ExtInventory\Data
 */
class SourceSelectionAlgorithmOptionSource implements OptionSourceInterface
{
    protected $options = null;
    /**
     * @var GetSourceSelectionAlgorithmListInterface
     */
    private $getSourceSelectionAlgorithmList;

    /**
     * SourceSelectionAlgorithmOptionSource constructor.
     * @param GetSourceSelectionAlgorithmListInterface $getSourceSelectionAlgorithmList
     */
    public function __construct(GetSourceSelectionAlgorithmListInterface $getSourceSelectionAlgorithmList)
    {
        $this->getSourceSelectionAlgorithmList = $getSourceSelectionAlgorithmList;
    }

    public function toOptionArray()
    {
        if ($this->options !== null) {
            return $this->options;
        }

        $algorithms = $this->getSourceSelectionAlgorithmList->execute();

        foreach ($algorithms as $algorithm) {
            $this->options[] = [
                'value' => $algorithm->getCode(),
                'label' => $algorithm->getTitle()
            ];

        }

        return $this->options;
    }
}
